% Experiment result of Figure 11 that is "Impact of the balancing parameter 
% on reconstructed errors when orthogonal wavelets is used".
%%
clc;
clear all;
close all;
clear classes;
%%
addpath('./Data')
addpath('./Operators')
addpath('./Solvers')
addpath('./Others')
%%
load im_ori_slice_7.mat
load mask_center_gradual_0.4.mat
%%
[row,column]=size(im_ori);
Fu = Fu_downsample(mask,row,column);
y = Fu*im_ori;
%% set SIDWT operator and C-SALSA-B algorrithm's paramters
filterType = 'Daubechies'; filterSize = 4;
wavescale = 4;   complex_yes=1;
params.psi = Rice_Wavelet_O(row,column,wavescale,filterType, filterSize,complex_yes);

params.lambda = 5e-2;     % regularization parameter
%% C-SALSA-B solver
h = waitbar(0,'Experimenting on RLNE V.S. gamma . . .');
gamma_test = 0:0.05:1;
for m=1:length(gamma_test)
    waitbar(m/length(gamma_test));
    params.gamma = gamma_test(m);   % balancing parameter which is in the range [0,1]. And gamma = 0
                                    % is of analysis model whereas gamma = 1 is of synthesis model.   
    im_rec = Solver_C_SALSA_B(y,mask,params);
    
    rlne_test(m) = RLNE(im_ori,im_rec);       % relative L2 norm error
end
close(h);
%% Resulets
figure,h = plot(gamma_test,rlne_test,'LineWidth',2);
legend(h,'DWT')
ylim([min(rlne_test)-0.01,max(rlne_test+0.01)]);
xlabel('\gamma','FontSize',20);
ylabel('RLNE','FontSize',20);
title('RLNE V.S. balancing paramter \gamma','FontSize',20);
grid on;set(gcf,'color','w');