% Experiment result of Figure 5 that is "Empirical convergence of C-SALSA-B".
%%
clc;
clear all;
close all;
clear classes;
%%
addpath('./Data')
addpath('./Operators')
addpath('./Solvers')
addpath('./Others')
%%
load im_ori_slice_7.mat
load mask_center_gradual_0.4.mat
%%
[row,column]=size(im_ori);
Fu = Fu_downsample(mask,row,column);
y = Fu*im_ori;
%% set SIDWT operator and C-SALSA-B algorrithm's paramters
filterType = 'Daubechies'; filterSize = 4;
wavescale = 4;   complex_yes=1;
params.psi = Rice_Wavelet(row,column,wavescale,filterType, filterSize,complex_yes);

params.lambda = 5e-2;     % regularization parameter
params.gamma = 1/2;       % balancing parameter which is in the range [0,1]. And gamma = 0
                          % is of analysis model whereas gamma = 1 is of synthesis model.
%% Solver
tic
[im_rec,obj_value]=Solver_C_SALSA_B_objective(y,mask,params);
run_time = toc
%% Resulets
rlne_err = RLNE(im_ori,im_rec)       % relative L2 norm error
figure,imshow(abs([im_ori im_rec]),[]);

figure,set(gcf,'color','w');
subplot(1,2,1),plot(obj_value(:,1)),title('Objective function of C-SALSA-B','FontSize',15);
xlabel('# iters','FontSize',15),ylabel('Value','FontSize',15);grid on;
subplot(1,2,2),plot(obj_value(:,2)),title('Value of constrained term of C-SALSA-B','FontSize',15);
xlabel('# iters','FontSize',15),ylabel('Value','FontSize',15);grid on;